/*
 * Copyright 2017 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package fr.gaellalire.vestige.spi.resolver.maven;

/**
 * @author Gael Lalire
 */
public interface ModifyDependencyRequest {

    /**
     * @since 2.0
     */
    void removeDependency(String groupId, String artifactId, String extension);

    /**
     * @since 3.3
     */
    void removeDependency(String groupId, String artifactId, String extension, String classifier);

    void addDependency(String groupId, String artifactId, String version);

    /**
     * @since 2.0
     */
    void addDependency(String groupId, String artifactId, String version, String extension);

    /**
     * @since 3.3
     */
    void addDependency(String groupId, String artifactId, String version, String extension, String classifier);

    /**
     * @since 2.1
     */
    void setPatch(final String groupId, final String artifactId, final String version);

    void execute();
}
